<?php

namespace dpd\Shipment\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for storeOrdersResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains return object.
 * - type: tns:storeOrdersResponse
 * @subpackage Structs
 */
class StoreOrdersResponse extends AbstractStructBase
{
    /**
     * The orderResult
     * Meta information extracted from the WSDL
     * - documentation: Contains return object.
     * @var \dpd\Shipment\StructType\StoreOrdersResponseType
     */
    public $orderResult;
    /**
     * Constructor method for storeOrdersResponse
     * @uses StoreOrdersResponse::setOrderResult()
     * @param \dpd\Shipment\StructType\StoreOrdersResponseType $orderResult
     */
    public function __construct(\dpd\Shipment\StructType\StoreOrdersResponseType $orderResult = null)
    {
        $this
            ->setOrderResult($orderResult);
    }
    /**
     * Get orderResult value
     * @return \dpd\Shipment\StructType\StoreOrdersResponseType|null
     */
    public function getOrderResult()
    {
        return $this->orderResult;
    }
    /**
     * Set orderResult value
     * @param \dpd\Shipment\StructType\StoreOrdersResponseType $orderResult
     * @return \dpd\Shipment\StructType\StoreOrdersResponse
     */
    public function setOrderResult(\dpd\Shipment\StructType\StoreOrdersResponseType $orderResult = null)
    {
        $this->orderResult = $orderResult;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dpd\Shipment\StructType\StoreOrdersResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
